<!--# This file is included inside page1.html #-->

<h3>What is a WebBox</h3>

<p>A WebBox is a template which has also some <em>PHP</em> code associated 
with it. It is a self-contained and independent template which can be easily 
included in other pages or in other applications. In fact, it may also have
some <em>JavaScript</em> code, <em>CSS</em> stylesheets, <em>SQL</em>
queries etc., associated with it.</p>

<p>It is denoted by the tag <strong>&amp;lt;WebBox&amp;gt;</strong> and it has an 
<strong>ID</strong> attribute:</p>
<example>  <webbox id="box_id">
    <!-- content of WebBox -->
  </webbox>
</example>
<p>The identifier must be different for each WebBox used in the 
application.</p>

<h3>The PHP code of the WebBox-es</h3>

<p>The <em>PHP</em> code (as well as <em>JS</em> code, <em>CSS</em>
styles etc.)  are associated to the WebBox by means of
<strong>box_id</strong>, the identifier of the WebBox.  When the
framework parses a <strong>&amp;lt;WebBox&amp;gt;</strong> tag, it looks for a
file named <strong>box_id.php</strong> in the same folder where the
WebBox template is. If it finds such a file, it includes it.</p>

<p>The <strong>box_id.php</strong> file must contain the definition 
of a <em>PHP</em> class that extends the class <strong>WebObject</strong>,
like this:</p>
<pre>
  &amp;lt;?php
  class <strong>box_id</strong> extends <strong>WebObject</strong>
  {
    .
    .
    .
  }
  ?&amp;gt;
</pre>

<p>The class <strong>WebObject</strong> is defined by the framework.
Among other things, it also contains the member function
<strong>WebObject::onRender()</strong>.</p>

<h3>The function <em>onRender()</em></h3>

<p>The function <strong>onRender()</strong> of the class
<em>WebObject</em> is called by the framework at the time of the
<em>HTML</em> page construction (the page that is sent to the
browser), just before the template of the WebBox is outputed
(rendered).  Actually <strong>WebObject::onRender()</strong> is an
abstract (empty) function, and the framework expects the class
<strong>box_id</strong> to override it, in order to do something
useful for the WebBox.What is usually done in
<strong>box_id::onRender()</strong> is assigning values to the
variables used in the template of the WebBox <em>box_id</em>, so that
the template is rendered properly.  These values are assigned by the
function <strong>WebApp::addVar("var_name", "var_value")</strong>.
</p>

<h3>Files related to a WebBox</h3>

<p>Besides the file that contains the template of the WebBox and the
<strong>box_id.php</strong> that contains its <em>PHP</em> class,
there may be other files as well that belong to the WebBox. These are:
<strong>box_id.js</strong> that contains the JavaScript code of the
WebBox, <strong>box_id.css</strong> that contains the stylesheet of
the WebBox, etc..  If the framework finds such files, it automatically
integrates them in the generated <em>HTML</em> page. For example, it
includes <strong>box_id.js</strong> and <strong>box_id.css</strong> in
the <em>&amp;lt;head&amp;gt;</em> of the page. If you view the HTML code of
this page, you may notice in the <em>&amp;lt;head&amp;gt;</em> these lines
that have been added automatically by the framework for the WebBox
<em>menu</em>:</p>

<pre>
  &amp;lt;script type='text/javascript' language='JavaScript' src='/app3/templates/menu/<strong>menu.js</strong>'&amp;gt;&amp;lt;/script&amp;gt;
  &amp;lt;link type='text/css' rel='stylesheet' href='/app3/templates/menu/<strong>menu.css</strong>'&amp;gt;
</pre>

<p>From the files of a WebBox, the template is the most
important. There can be a WebBox without <em>JS</em> code or without
<em>PHP</em> code, but there cannot be a WebBox without
<em>TPL</em>(template) code.</p>


<h3>Differences with templates</h3>

<p>A WebBox is defined inside a template file and the <em>TPL</em>
code of the WebBox is inside the <em>&amp;lt;WebBox&amp;gt;</em> tag (is the
content of the <em>&amp;lt;WebBox&amp;gt;</em> element). However a WebBox is
different from a template because it can also have its own
<em>PHP</em> code. Another difference is that a template must include
explicitly the <em>JS</em> code and the <em>CSS</em> code (if it has
its own), however, for a WebBox the framework handles them
automatically, by including them at the <em>&amp;lt;head&amp;gt;</em> of the
page</p>
